package com.mortals.xhx.common.utils;

import lombok.extern.slf4j.Slf4j;

import java.security.MessageDigest;

@Slf4j
public class EncryptionUtils {
    private enum DigestType{

        MD5("MD5"),
        SHA("SHA"),
        SHA256("SHA-256");

        private String name;

        private DigestType(String name){
            this.name = name;
        }

        public String getName() {
            return name;
        }
    }

    private final static String digest(String sourceStr,DigestType type) {
        char hexDigits[]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
        try {
            byte[] btInput = sourceStr.getBytes();
            // 获得摘要算法的 MessageDigest 对象
            MessageDigest mdInst = MessageDigest.getInstance(type.name);
            // 使用指定的字节更新摘要
            mdInst.update(btInput);
            // 获得密文
            byte[] md = mdInst.digest();
            // 把密文转换成十六进制的字符串形式
            int length = md.length;
            char str[] = new char[length * 2];
            int k = 0;
            for (int i = 0; i < length; i++) {
                byte byte0 = md[i];
                str[k++] = hexDigits[byte0 >>> 4 & 0xf];
                str[k++] = hexDigits[byte0 & 0xf];
            }
            return new String(str);
        } catch (Exception e) {
            log.error("签名失败", e);
            return "";
        }
    }

    public final static String MD5(String s) {
        return digest(s, DigestType.MD5);
    }

    public final static String SHA(String s) {
        return digest(s, DigestType.SHA);
    }

    public final static String SHA256(String s){
        return digest(s, DigestType.SHA256);
    }
}
